// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dataspeed_dbw_msgs:msg/BrakeReport.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_DBW_MSGS__MSG__DETAIL__BRAKE_REPORT__STRUCT_H_
#define DATASPEED_DBW_MSGS__MSG__DETAIL__BRAKE_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'watchdog_counter'
#include "dataspeed_dbw_msgs/msg/detail/watchdog_counter__struct.h"

// Struct defined in msg/BrakeReport in the package dataspeed_dbw_msgs.
typedef struct dataspeed_dbw_msgs__msg__BrakeReport
{
  std_msgs__msg__Header header;
  float pedal_input;
  float pedal_cmd;
  float pedal_output;
  float torque_input;
  float torque_cmd;
  float torque_output;
  float decel_cmd;
  float decel_output;
  bool boo_cmd;
  bool enabled;
  bool override;
  bool driver;
  bool timeout;
  dataspeed_dbw_msgs__msg__WatchdogCounter watchdog_counter;
  bool watchdog_braking;
  bool fault_wdc;
  bool fault_ch1;
  bool fault_ch2;
  bool fault_power;
} dataspeed_dbw_msgs__msg__BrakeReport;

// Struct for a sequence of dataspeed_dbw_msgs__msg__BrakeReport.
typedef struct dataspeed_dbw_msgs__msg__BrakeReport__Sequence
{
  dataspeed_dbw_msgs__msg__BrakeReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dataspeed_dbw_msgs__msg__BrakeReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DATASPEED_DBW_MSGS__MSG__DETAIL__BRAKE_REPORT__STRUCT_H_
