// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dataspeed_dbw_msgs:msg/SteeringCmd.idl
// generated code does not contain a copyright notice
#include "dataspeed_dbw_msgs/msg/detail/steering_cmd__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
dataspeed_dbw_msgs__msg__SteeringCmd__init(dataspeed_dbw_msgs__msg__SteeringCmd * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dataspeed_dbw_msgs__msg__SteeringCmd__fini(msg);
    return false;
  }
  // steering_wheel_angle_cmd
  // steering_wheel_angle_velocity
  // steering_wheel_torque_cmd
  // cmd_type
  // enable
  // clear
  // ignore
  // calibrate
  // quiet
  // alert
  // count
  return true;
}

void
dataspeed_dbw_msgs__msg__SteeringCmd__fini(dataspeed_dbw_msgs__msg__SteeringCmd * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // steering_wheel_angle_cmd
  // steering_wheel_angle_velocity
  // steering_wheel_torque_cmd
  // cmd_type
  // enable
  // clear
  // ignore
  // calibrate
  // quiet
  // alert
  // count
}

bool
dataspeed_dbw_msgs__msg__SteeringCmd__are_equal(const dataspeed_dbw_msgs__msg__SteeringCmd * lhs, const dataspeed_dbw_msgs__msg__SteeringCmd * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // steering_wheel_angle_cmd
  if (lhs->steering_wheel_angle_cmd != rhs->steering_wheel_angle_cmd) {
    return false;
  }
  // steering_wheel_angle_velocity
  if (lhs->steering_wheel_angle_velocity != rhs->steering_wheel_angle_velocity) {
    return false;
  }
  // steering_wheel_torque_cmd
  if (lhs->steering_wheel_torque_cmd != rhs->steering_wheel_torque_cmd) {
    return false;
  }
  // cmd_type
  if (lhs->cmd_type != rhs->cmd_type) {
    return false;
  }
  // enable
  if (lhs->enable != rhs->enable) {
    return false;
  }
  // clear
  if (lhs->clear != rhs->clear) {
    return false;
  }
  // ignore
  if (lhs->ignore != rhs->ignore) {
    return false;
  }
  // calibrate
  if (lhs->calibrate != rhs->calibrate) {
    return false;
  }
  // quiet
  if (lhs->quiet != rhs->quiet) {
    return false;
  }
  // alert
  if (lhs->alert != rhs->alert) {
    return false;
  }
  // count
  if (lhs->count != rhs->count) {
    return false;
  }
  return true;
}

bool
dataspeed_dbw_msgs__msg__SteeringCmd__copy(
  const dataspeed_dbw_msgs__msg__SteeringCmd * input,
  dataspeed_dbw_msgs__msg__SteeringCmd * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // steering_wheel_angle_cmd
  output->steering_wheel_angle_cmd = input->steering_wheel_angle_cmd;
  // steering_wheel_angle_velocity
  output->steering_wheel_angle_velocity = input->steering_wheel_angle_velocity;
  // steering_wheel_torque_cmd
  output->steering_wheel_torque_cmd = input->steering_wheel_torque_cmd;
  // cmd_type
  output->cmd_type = input->cmd_type;
  // enable
  output->enable = input->enable;
  // clear
  output->clear = input->clear;
  // ignore
  output->ignore = input->ignore;
  // calibrate
  output->calibrate = input->calibrate;
  // quiet
  output->quiet = input->quiet;
  // alert
  output->alert = input->alert;
  // count
  output->count = input->count;
  return true;
}

dataspeed_dbw_msgs__msg__SteeringCmd *
dataspeed_dbw_msgs__msg__SteeringCmd__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_dbw_msgs__msg__SteeringCmd * msg = (dataspeed_dbw_msgs__msg__SteeringCmd *)allocator.allocate(sizeof(dataspeed_dbw_msgs__msg__SteeringCmd), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dataspeed_dbw_msgs__msg__SteeringCmd));
  bool success = dataspeed_dbw_msgs__msg__SteeringCmd__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
dataspeed_dbw_msgs__msg__SteeringCmd__destroy(dataspeed_dbw_msgs__msg__SteeringCmd * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    dataspeed_dbw_msgs__msg__SteeringCmd__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
dataspeed_dbw_msgs__msg__SteeringCmd__Sequence__init(dataspeed_dbw_msgs__msg__SteeringCmd__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_dbw_msgs__msg__SteeringCmd * data = NULL;

  if (size) {
    data = (dataspeed_dbw_msgs__msg__SteeringCmd *)allocator.zero_allocate(size, sizeof(dataspeed_dbw_msgs__msg__SteeringCmd), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dataspeed_dbw_msgs__msg__SteeringCmd__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dataspeed_dbw_msgs__msg__SteeringCmd__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dataspeed_dbw_msgs__msg__SteeringCmd__Sequence__fini(dataspeed_dbw_msgs__msg__SteeringCmd__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dataspeed_dbw_msgs__msg__SteeringCmd__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dataspeed_dbw_msgs__msg__SteeringCmd__Sequence *
dataspeed_dbw_msgs__msg__SteeringCmd__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_dbw_msgs__msg__SteeringCmd__Sequence * array = (dataspeed_dbw_msgs__msg__SteeringCmd__Sequence *)allocator.allocate(sizeof(dataspeed_dbw_msgs__msg__SteeringCmd__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = dataspeed_dbw_msgs__msg__SteeringCmd__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
dataspeed_dbw_msgs__msg__SteeringCmd__Sequence__destroy(dataspeed_dbw_msgs__msg__SteeringCmd__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    dataspeed_dbw_msgs__msg__SteeringCmd__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
dataspeed_dbw_msgs__msg__SteeringCmd__Sequence__are_equal(const dataspeed_dbw_msgs__msg__SteeringCmd__Sequence * lhs, const dataspeed_dbw_msgs__msg__SteeringCmd__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!dataspeed_dbw_msgs__msg__SteeringCmd__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
dataspeed_dbw_msgs__msg__SteeringCmd__Sequence__copy(
  const dataspeed_dbw_msgs__msg__SteeringCmd__Sequence * input,
  dataspeed_dbw_msgs__msg__SteeringCmd__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(dataspeed_dbw_msgs__msg__SteeringCmd);
    dataspeed_dbw_msgs__msg__SteeringCmd * data =
      (dataspeed_dbw_msgs__msg__SteeringCmd *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!dataspeed_dbw_msgs__msg__SteeringCmd__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          dataspeed_dbw_msgs__msg__SteeringCmd__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!dataspeed_dbw_msgs__msg__SteeringCmd__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
