// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dataspeed_dbw_msgs:msg/WatchdogCounter.idl
// generated code does not contain a copyright notice
#include "dataspeed_dbw_msgs/msg/detail/watchdog_counter__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
dataspeed_dbw_msgs__msg__WatchdogCounter__init(dataspeed_dbw_msgs__msg__WatchdogCounter * msg)
{
  if (!msg) {
    return false;
  }
  // source
  return true;
}

void
dataspeed_dbw_msgs__msg__WatchdogCounter__fini(dataspeed_dbw_msgs__msg__WatchdogCounter * msg)
{
  if (!msg) {
    return;
  }
  // source
}

bool
dataspeed_dbw_msgs__msg__WatchdogCounter__are_equal(const dataspeed_dbw_msgs__msg__WatchdogCounter * lhs, const dataspeed_dbw_msgs__msg__WatchdogCounter * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // source
  if (lhs->source != rhs->source) {
    return false;
  }
  return true;
}

bool
dataspeed_dbw_msgs__msg__WatchdogCounter__copy(
  const dataspeed_dbw_msgs__msg__WatchdogCounter * input,
  dataspeed_dbw_msgs__msg__WatchdogCounter * output)
{
  if (!input || !output) {
    return false;
  }
  // source
  output->source = input->source;
  return true;
}

dataspeed_dbw_msgs__msg__WatchdogCounter *
dataspeed_dbw_msgs__msg__WatchdogCounter__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_dbw_msgs__msg__WatchdogCounter * msg = (dataspeed_dbw_msgs__msg__WatchdogCounter *)allocator.allocate(sizeof(dataspeed_dbw_msgs__msg__WatchdogCounter), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dataspeed_dbw_msgs__msg__WatchdogCounter));
  bool success = dataspeed_dbw_msgs__msg__WatchdogCounter__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
dataspeed_dbw_msgs__msg__WatchdogCounter__destroy(dataspeed_dbw_msgs__msg__WatchdogCounter * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    dataspeed_dbw_msgs__msg__WatchdogCounter__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence__init(dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_dbw_msgs__msg__WatchdogCounter * data = NULL;

  if (size) {
    data = (dataspeed_dbw_msgs__msg__WatchdogCounter *)allocator.zero_allocate(size, sizeof(dataspeed_dbw_msgs__msg__WatchdogCounter), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dataspeed_dbw_msgs__msg__WatchdogCounter__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dataspeed_dbw_msgs__msg__WatchdogCounter__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence__fini(dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dataspeed_dbw_msgs__msg__WatchdogCounter__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence *
dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence * array = (dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence *)allocator.allocate(sizeof(dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence__destroy(dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence__are_equal(const dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence * lhs, const dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!dataspeed_dbw_msgs__msg__WatchdogCounter__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence__copy(
  const dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence * input,
  dataspeed_dbw_msgs__msg__WatchdogCounter__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(dataspeed_dbw_msgs__msg__WatchdogCounter);
    dataspeed_dbw_msgs__msg__WatchdogCounter * data =
      (dataspeed_dbw_msgs__msg__WatchdogCounter *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!dataspeed_dbw_msgs__msg__WatchdogCounter__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          dataspeed_dbw_msgs__msg__WatchdogCounter__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!dataspeed_dbw_msgs__msg__WatchdogCounter__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
